package org.codehaus.cargo.maven2;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on cargo-maven2-plugin.<br/> Call <pre>  mvn cargo:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Wed Aug 22 00:29:20 CEST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.7)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.codehaus.cargo:cargo-maven2-plugin:1.2.4", 0 );
        append( sb, "", 0 );

        append( sb, "Cargo Maven 2 Plugin", 0 );
        append( sb, "Cargo Maven 2 Plugin", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 16 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "configure".equals( goal ) )
        {
            append( sb, "cargo:configure", 0 );
            append( sb, "Mojo to create a local container standalone configuration at a specified directory.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deploy".equals( goal ) )
        {
            append( sb, "cargo:deploy", 0 );
            append( sb, "Class used uniquely to provide a goal alias for deployer-deploy.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deployer-deploy".equals( goal ) )
        {
            append( sb, "cargo:deployer-deploy", 0 );
            append( sb, "Deploy a deployable to a container.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deployer-redeploy".equals( goal ) )
        {
            append( sb, "cargo:deployer-redeploy", 0 );
            append( sb, "Redeploy a deployable (i.e. undeploy and deploy it again) in a container.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deployer-start".equals( goal ) )
        {
            append( sb, "cargo:deployer-start", 0 );
            append( sb, "Start a deployable which is already installed in a container.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deployer-stop".equals( goal ) )
        {
            append( sb, "cargo:deployer-stop", 0 );
            append( sb, "Stop a deployable which is already deployed in a container.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deployer-undeploy".equals( goal ) )
        {
            append( sb, "cargo:deployer-undeploy", 0 );
            append( sb, "Undeploy a deployable from a container.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "cargo:help", 0 );
            append( sb, "Display help information on cargo-maven2-plugin.\nCall\n\u00a0\u00a0mvn\u00a0cargo:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "install".equals( goal ) )
        {
            append( sb, "cargo:install", 0 );
            append( sb, "Installs a container into a given directory. If the container is already installed nothing happens. The container is defined using the <container> element as described in the Cargo Maven2 plugin reference guide.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "package".equals( goal ) )
        {
            append( sb, "cargo:package", 0 );
            append( sb, "Package a container distribution, a Configuration and deployed deployables. See Packager.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "packager", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "redeploy".equals( goal ) )
        {
            append( sb, "cargo:redeploy", 0 );
            append( sb, "Class used uniquely to provide a goal alias for deployer-redeploy.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "run".equals( goal ) )
        {
            append( sb, "cargo:run", 0 );
            append( sb, "Start a container using Cargo and wait until user pressed CTRL + C to stop.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "containerId", 2 );
                append( sb, "Sets the container id.", 3 );
                append( sb, "Expression: ${cargo.maven.containerId}", 3 );
                append( sb, "", 0 );

                append( sb, "containerUrl", 2 );
                append( sb, "Sets the container download URL.", 3 );
                append( sb, "Expression: ${cargo.maven.containerUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "start".equals( goal ) )
        {
            append( sb, "cargo:start", 0 );
            append( sb, "Start a container using Cargo.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );

                append( sb, "wait (Default: false)", 2 );
                append( sb, "Deprecated. The wait parameter is now deprecated, please use cargo:run instead", 3 );
                append( sb, "", 0 );
                append( sb, "Decides whether to wait after the container is started or to return the execution flow to the user.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${cargo.maven.wait}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "stop".equals( goal ) )
        {
            append( sb, "cargo:stop", 0 );
            append( sb, "Stop a running container using Cargo.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "uberwar".equals( goal ) )
        {
            append( sb, "cargo:uberwar", 0 );
            append( sb, "Builds an uber war.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "archive", 2 );
                append( sb, "The archive configuration to use. See Maven Archiver Reference.", 3 );
                append( sb, "", 0 );

                append( sb, "descriptor", 2 );
                append( sb, "The file name to use for the merge descriptor.", 3 );
                append( sb, "", 0 );

                append( sb, "descriptorId", 2 );
                append( sb, "The id to use for the merge descriptor.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "The directory for the generated WAR.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.directory}", 3 );
                append( sb, "", 0 );

                append( sb, "resolveDependencies", 2 );
                append( sb, "Attempt to resolve dependencies, rather than simply merging the files in WEB-INF/lib. This is an experimental feature.", 3 );
                append( sb, "", 0 );

                append( sb, "warName", 2 );
                append( sb, "The name of the generated WAR.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${project.build.finalName}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "undeploy".equals( goal ) )
        {
            append( sb, "cargo:undeploy", 0 );
            append( sb, "Class used uniquely to provide a goal alias for deployer-undeploy.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "configuration", 2 );
                append( sb, "Configures a Cargo Configuration. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "container", 2 );
                append( sb, "Configures a Cargo Container. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployables", 2 );
                append( sb, "List of Deployable. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "deployer", 2 );
                append( sb, "Configures a Cargo Deployer. See the Cargo Maven2 plugin reference guide for more details.", 3 );
                append( sb, "", 0 );

                append( sb, "skip (Default: false)", 2 );
                append( sb, "Set this to \'true\' to bypass cargo execution.", 3 );
                append( sb, "Expression: ${cargo.maven.skip}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
